"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class XMLSnippets {
}
exports.XMLSnippets = XMLSnippets;
XMLSnippets.xsltRootTags = [
    {
        name: 'XML Root Element Snippet',
        description: 'Basic XML Template',
        body: `?xml version="1.0" encoding="UTF-8"?>
<\${1:element} \${2:attribute}="\${3:value}">
			 
\t<\${4:childElement}>
\t\t$0
\t</\${4:childElement}>
			 
</\${1:element}>`
    }
];
XMLSnippets.generalTags = [
    {
        name: 'block-start-end-tag-with',
        description: 'with attribute',
        body: `\${1:element} \${2:attribute}="\${3:value}">			 
\t\$0						 
</\${1:element}>`
    },
    {
        name: 'inline-start-end-tag-with',
        description: 'with attribute',
        body: `\${1:element} \${2:attribute}="\${3:value}">\${4:text}</\${1:element}>$0`
    },
    {
        name: 'self-closed-tag-with',
        description: 'with attribute',
        body: `\${1:element} \${2:attribute}="\${3:value}"\$0/>`
    },
    {
        name: 'block-start-end-tag',
        description: 'no attribute',
        body: `\${1:element}>			 
\t\$0						 
</\${1:element}>`
    },
    {
        name: 'inline-start-end-tag',
        description: 'no attribute',
        body: `\${1:element}>\${2:text}</\${1:element}>$0`
    },
    {
        name: 'self-closed-tag',
        description: 'no attribute',
        body: `\${1:element}$0/>`
    }
];
XMLSnippets.generalAttributes = [
    {
        name: 'attribute',
        description: 'attribute name="value"',
        body: `\${1:name}="\${2:value}"$0`
    }
];
//# sourceMappingURL=xmlSnippets.js.map