"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const xslLexer_1 = require("./xslLexer");
const diagnostics_1 = require("./diagnostics");
const languageConfigurations_1 = require("./languageConfigurations");
// -------------
let testXslt = `<b s="q{{k}}"/>`;
let testTitle = `declaration`;
let generateTest = false;
let timerOnly = false;
// =============
generateTest = timerOnly ? false : generateTest;
let debugOn;
if (timerOnly) {
    debugOn = false;
    testXslt = testXslt.repeat(5000);
}
else {
    debugOn = !generateTest;
}
let lexer = new xslLexer_1.XslLexer(languageConfigurations_1.XSLTConfiguration.configuration);
lexer.debug = debugOn;
lexer.timerOn = timerOnly;
let tokens = lexer.analyse(testXslt);
diagnostics_1.Debug.printTokenValues(testXslt, tokens);
//# sourceMappingURL=xslLexerRun.js.map